package com.sundata.internalevaluation.configuration.controller;

import com.sundata.common.base.BaseAction;
import com.sundata.internalevaluation.calc.calcUnit.IndexCalcUnit;
import com.sundata.internalevaluation.calc.running.threads.CalcTaskResult;
import com.sundata.internalevaluation.calc.util.CalcUtil;
import com.sundata.internalevaluation.configuration.model.DataSetConfigModel;
import com.sundata.internalevaluation.configuration.model.DataSourcesModel;
import com.sundata.internalevaluation.configuration.model.IndexConfigModel;
import com.sundata.internalevaluation.configuration.service.IndexConfigService;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/internalevaluation/configuration/IndexConfigAction")
public class IndexConfigAction extends BaseAction {

    @Autowired
    IndexConfigService indexConfigService;

    /**
     * @author: 张艳杰
     * @methodsName: getDataList
     * @description: 指标配置初始化
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexConfigModel model
     * @return: List<IndexConfigModel>
     * @throws:
     */
    @RequestMapping({"getDataList"})
    public List<IndexConfigModel> getDataList(HttpServletRequest request, HttpServletResponse response,
                                                @RequestBody IndexConfigModel model) {
        return indexConfigService.getDataList(model);

    }

    /**
     * @author: 张艳杰
     * @methodsName: createData
     * @description: 指标配置新增
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexConfigModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"createData"})
    public void createData(HttpServletRequest request, HttpServletResponse response,
                           @RequestBody IndexConfigModel model) {
        indexConfigService.createData(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: deleteRows
     * @description: 指标配置删除
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexConfigModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"deleteRows"})
    public void deleteRows(HttpServletRequest request, HttpServletResponse response,
                           @RequestBody IndexConfigModel model) {
        indexConfigService.deleteRows(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: updateExistData
     * @description: 指标配置修改
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexConfigModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"updateExistData"})
    public void updateExistData(HttpServletRequest request, HttpServletResponse response,
                                @RequestBody IndexConfigModel model) {
        indexConfigService.updateExistData(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: selectDetailData
     * @description: 指标配置查询
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexConfigModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"selectDetailData"})
    public IndexConfigModel selectDetailData(HttpServletRequest request, HttpServletResponse response,
                                               @RequestBody IndexConfigModel model) {

//        System.out.println("****** 计算开始 *******");
//        IndexConfigModel configModel = new IndexConfigModel();
//        configModel.setIndexNo("001");
//        configModel.setIndexName("测试");
//        CalcTaskResult calc = CalcUtil.calc("INDEX"+System.currentTimeMillis(),
//                new IndexCalcUnit(configModel.getIndexNo(),configModel.getIndexName(), Map.of(),configModel,indexConfigService),Map.of());
//
//        System.out.println("结果："+calc);

        return indexConfigService.selectDetailData(model);
    }
}
