package com.sundata.internalevaluation.configuration.controller;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.sundata.common.base.BaseAction;
import com.sundata.internalevaluation.calc.util.CalcUtil;
import com.sundata.internalevaluation.configuration.model.SysReqRules;
import com.sundata.internalevaluation.configuration.service.SysReqRulesService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/nprules")
public class SysReqRulesController extends BaseAction {

    @Autowired
    private SysReqRulesService sysReqRulesService;

    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    @RequestMapping("list")
    public List<SysReqRules> listAll(@RequestBody SysReqRules sysReqRules) {
        return sysReqRulesService.listAll(sysReqRules);
    }


    /**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
    @RequestMapping("getById")
    public SysReqRules getById(@RequestBody SysReqRules sysReqRules) {
        return sysReqRulesService.getById(sysReqRules.getRulesNo());
    }    
     
    /**
     * 新增，忽略null字段
     *
     * @param sysReqRules 新增的记录
     * @return 返回影响行数
     */
    @RequestMapping("insert")
    public int insert(@RequestBody SysReqRules sysReqRules) throws JsonProcessingException {
        return sysReqRulesService.insertIgnoreNull(sysReqRules);
    }    
      
    /**
     * 修改，忽略null字段
     *
     * @param sysReqRules 修改的记录
     * @return 返回影响行数
     */
    @RequestMapping("update")
    public int update(@RequestBody SysReqRules sysReqRules) {
        return sysReqRulesService.updateIgnoreNull(sysReqRules);
    }
    
    /**
     * 删除记录
     *
     * @param sysReqRules 待删除的记录
     * @return 返回影响行数
     */
    @RequestMapping("delete")
    public int delete(@RequestBody SysReqRules sysReqRules) {
        return sysReqRulesService.delete(sysReqRules);
    }


    @RequestMapping("testRules")
    public Object testRules(@RequestBody SysReqRules sysReqRules) {
        return CalcUtil.calcRules("rules"+System.currentTimeMillis(), sysReqRules.getRulesNo(), Map.of("name","zhangsan","custNo","1"));
    }
    
}