package com.sundata.internalevaluation.configuration.mapper;

import com.sundata.internalevaluation.configuration.model.SysReqRule;
import com.sundata.internalevaluation.configuration.model.SysRuleIndex;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface SysReqRuleMapper {

	/**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
	List<SysReqRule> listAll(SysReqRule sysReqRule);


	/**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
	SysReqRule getById(String ruleNo);

	
	/**
     * 新增，忽略null字段
     *
     * @param sysReqRule 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(SysReqRule sysReqRule);

	
	/**
     * 修改，忽略null字段
     *
     * @param sysReqRule 修改的记录
     * @return 返回影响行数
     */
	int updateIgnoreNull(SysReqRule sysReqRule);
	
	/**
     * 删除记录
     *
     * @param sysReqRule 待删除的记录
     * @return 返回影响行数
     */
	int delete(SysReqRule sysReqRule);

	List<SysReqRule> selectRuleListByRulesNo(@Param("rulesNo") String rulesNo);


	/**
	 * 根据规则编号删除所有指标
	 * @param ruleNo 规则编号
	 * @return 返回影响行数
	 */
	int deleteIndexByRuleNo(@Param("ruleNo") String ruleNo);


	/**
	 * 插入所有规则 指标管关联关系
	 * @param list 集合
	 * @return 返回影响行数
	 */
	int insertIndexList(@Param("list") List<SysRuleIndex> list);

	/**
	 * 根据规则的编号  查询关联的指标
	 * @param ruleNo 规则编号
	 * @return 返回集合
	 */
	List<String> selectIndexByRuleNo(@Param("ruleNo") String ruleNo);

	/**
	 * 根据规则的编号  查询关联的指标
	 * @param ruleNo 规则编号
	 * @return 返回集合
	 */
	List<SysRuleIndex> selectRuleIndexListByRuleNo(@Param("ruleNo") String ruleNo);
}